<template>
  <v-app>
    <v-navigation-drawer
      v-model="drawer"
      :mini-variant="miniVariant"
      :clipped="!clipped"
      expand-on-hover
      permanent
      app
    >
      <v-list>
        <v-list-item
          v-for="(item, i) in items"
          :key="i"
          :to="item.to"
          router
          exact
        >
          <v-list-item-action>
            <v-icon>{{ item.icon }}</v-icon>
          </v-list-item-action>
          <v-list-item-content>
            <v-list-item-title v-text="item.title" />
          </v-list-item-content>
        </v-list-item>
      </v-list>
    </v-navigation-drawer>
    <v-app-bar :clipped-left="!clipped" fixed app>
      <v-app-bar-nav-icon @click.stop="drawer = !drawer" xs12 md12 gl12 />
      <v-toolbar-title v-text="title" />
      <v-spacer />
      <v-btn @click="checkUser" data-cy="button_login_user">{{
        this.currentUser ? 'Cerrar sesión' : 'Iniciar sesión'
      }}</v-btn>
    </v-app-bar>
    <v-content>
      <v-container>
        <nuxt />
      </v-container>
    </v-content>
    <v-footer :fixed="fixed" app>
      <span>&copy; 2019</span>
    </v-footer>
  </v-app>
</template>

<script>
import Vue from 'vue'
import VueRouter from 'vue-router'
Vue.use(VueRouter)
export default {
  data() {
    return {
      clipped: false,
      drawer: false,
      fixed: false,
      items: [
        {
          icon: 'mdi-chart-bubble',
          title: 'Cargar datos',
          to: '/load-data'
        },
        {
          icon: 'mdi-format-list-checks',
          title: 'Certificados',
          to: '/certificate-data'
        },
        {
          icon: 'mdi-map',
          title: 'Analytics',
          to: '/analytics-data'
        }
      ],
      miniVariant: true,
      right: true,
      rightDrawer: false,
      title: 'SingleTally',
      text_btn: 'Cierra tu sesión',
      currentUser: '',
      currentUserEmail: ''
    }
  },
  mounted() {
    this.checkFirebase()
  },
  methods: {
    checkFirebase() {
      const self = this
      this.$firebase.auth().onAuthStateChanged(
        function(user) {
          if (user) {
            self.currentUser = user.displayName
            self.currentUserEmail = user.email
            user.getIdToken().then(function(accessToken) {})
          } else {
          }
        },
        function(error) {
          console.log(error)
        }
      )
    },
    checkUser() {
      const self = this
      self.currentUser ? self.singOut() : self.signIn()
    },
    signIn() {
      this.$router.push({ path: '/' })
    },
    singOut() {
      const self = this
      this.$firebase.auth().onAuthStateChanged(
        function(user) {
          if (user) {
            self.$firebase
              .auth()
              .signOut()
              .then(function() {
                self.currentUser = null
                self.$router.push({ path: '/' })
              })
              .catch(function(error) {
                console.error(error)
                // An error happened.
              })
          } else {
          }
        },
        function(error) {
          console.log(error)
        }
      )
    }
  }
}
</script>
